/*
 * common functions
 */
#if !defined (min)
#define min(a,b) ((a <= b)? (a) : (b))
#endif
#if !defined (max)
#define max(a,b) ((a >= b)? (a) : (b))
#endif
#if !defined (sign)
#define sign(a) ((a<0)? (-1) : (1))
#endif

/*
 * functions in sdpallo.c
 */
int       *iAlloc(int,char*);
void      iFree(int**);
double    *dAlloc(int,char*);
void      dFree(double**);
void      cFree(char**);
smatx     *mAlloc(int,int,char*);
void      mFree(smatx **);
symat     *SymAlloc(int,int,char*); 
void      SymFree(symat**);
syoff     *SyoAlloc(int,int,char*); 
void      SyoFree(syoff**); 
int       LvalAlloc(chfac*,char*);
chfac     *CfcAlloc(int,char*);
void      CfcFree(chfac**);
double    **dPtAlloc(int,char*); 
void      dPtFree(double***);
smwTools* wAlloc(int,int);
void      wFree(smwTools**);

void    WorkMem(sdpdat*);

/* Funtions in sdptime.c */
clock_t GetTime(void);
int     SetTime(clock_t*,int);
double  TimeInSec(clock_t,clock_t);

/* 
 * functions in sdpmain.c 
 */ 
int     main(int argc,char *argv[]);
void    GetLhat(sdpdat*);
void    GetVhat(double*,double*,sdpdat*);
void    GetUhat(chfac*,double*,double*);

/*
 * functions in sdpproc.c
 */
void    SdpProc(sdpdat*);
void    PostProc(sdpdat*);

/*
 * functions in sdpshut.c
 */
void    ShutDown(void);
int     ExitProc(int,char*);


/*
 * functions in sdplib.a
 */
int     InvMemo(sdpdat*);
void    FindSinv(chfac*,syoff*,double*,double*,double*,double);
void    FindInver(chfac*,syoff*,double*,sdpdat*);
void    DotProd(double*,chfac*);
void    Smt2Sym(smatx*,symat**);
void    ForwSubst(chfac*,double*,double*);
int     iSum(int,int*);
void    dCopy(int,double*,double*);
int     ChlFact(chfac*,int*,double*,int);
void    ChlSolve(chfac*,double*,double*);
int     SymbProc(int*,int*,sdpdat*);
int     InvSymbo(syoff*,chfac*);
void    CfcInit(chfac*,symat*,double*); 
void    ModUppBnd(sdpdat*,double*,double*,double*,
                  double*,double,double,double*,double);
void    FixIndex(sdpdat*);
void    iCopy(int,int*,int*);

order  *OdAlloc(int,int,char*);
void   OdFree(order**);
void   OdInit(order*,int*);
void   OdIndex(order*,int,int);
void   OdProc(order*,xlist*,int*,int*,int*,int*,int*,
              int*,int*,int*,int*,int*,int*,int*,int*);
int    GetOrder(order*,int*);

int    SmatxTrans(int,smatx*,int,int*,smatx**);
double GetFnorm(int,smatx*);
void   SmtCopy(int,smatx*,smatx*);
void   ChlSolve(chfac*,double*,double*);
void   FindInver(chfac*,syoff*,double*,sdpdat*);
void   DotProd(double*,chfac*);
void   Smt2Sym(smatx*,symat**);
void   MtxTimesVct(int,int,smatx*,double*,double*,int);
double SymSum(symat*);

void   CfcInit(chfac*,symat*,double*);
int    ChlFact(chfac*,int*,double*,int);
void   copyChl(chfac *, chfac *);

void   PermSmatx(smatx*,int*,int*);

xlist  *XtAlloc(int,int,char*);
void   XtFree(xlist**);
int    XtSucc(xlist*);
void   XtDel(xlist*,int);
void   XtPut(xlist*,int,int);
int    XtLeast(xlist*);
int    XtGet(xlist*,int*,int*);

void   IptAlloc(int,int,int**,char*);
void   IptFree(int,int**);
int    LocIntPos(int,int,int*);
void   PermTransSym(int,int*,int*,int*,int*,int,int*,int*,int*);
int    PspSymbo(symat*,chfac*);
int    InvSymbo(syoff*,chfac*); 

void   iZero(int,int*,int*);
void   iFill(int,int,int*,int*,int*);
void   iSwap(int,int,int*);
void   iCopy(int,int*,int*);
int    iSum(int,int*);
void   dZero(int,double*,int*,int*);
void   dCopy(int,double*,double*);
void   dCat(int,int*,double*,double*);
double dSum(int,double*);
void   PlusByOne(int,int*,int*,int*);

void iSet(int, int, int *, int *);
void plusXs(int, int*, int*);



