#include "SDPdef.h"

void ShutDown(){

  sdpdat* sdt = sdat;
  clock_t tim;
  
  if (sdt->rgap >sdt->par.rgaptol) 
  {
    tim=GetTime()-stim[START];
  
#ifdef UNIXMACH
    printf(" time=%.2f\n\n",(double)0.01*tim);
#else
    printf(" time=%.2f\n\n",(double)tim/CLOCKS_PER_SEC);
#endif

    if (fout) fclose(fout);
  }
  free(sdt->rtyp);
  sdt->rtyp=NULL;
  dFree(&sdt->rhs2);
  dFree(&sdt->y);
  dFree(&sdt->ytemp);
  dFree(&sdt->yt2);
  dFree(&sdt->dy1);
  dFree(&sdt->dy2);
  dFree(&sdt->dy);
  dFree(&sdt->xmakery);
  dFree(&sdt->xmakerdy);
  dFree(&sdt->s);
  dFree(&sdt->b);       /* Allocated in DataIn() */
  dFree(&sdt->cvec);
  mFree(&sdt->avecs);
  mFree(&sdt->amats);
  SymFree(&sdt->cmat);
  
  CfcFree(&sdt->sf);
  CfcFree(&sdt->rf);
  CfcFree(&sdt->mf);
  sdt->gram=NULL;
  sdt->dgram = NULL;
    
  wFree(&sdt->smw); 
  iFree(&sdt->useSMW);
  iFree(&sdt->iw);
  dFree(&sdt->rw);
  dFree(&sdt->wd);
  dFree(&sdt->wd2);
  dFree(&sdt->vhat);
  dFree(&sdt->vsol);
  dFree(&sdt->bestv);
  

} /* ShutDown */


int ExitProc(int  code,
             char *str)
{
  printf("\n Exit -- %d: ",code);
  
  switch (code) {
    case OptFound:
      printf("optimal solution found");
      return code;
    case OutOfSpc:
      printf("out of memory space");
      break;
    case IterLimit:
      printf("too many iterations");
      break;
    case WriteFail:
      printf("can't create file");
      break;
    case ReadFail:
      printf("can't open file");
      break;
    case BadInitPoint:
      printf("Infeasible initial point");
      break;
    case DataInputError:
      printf("Data input error");
      break;
    default:
      break;
  }
  if (str) printf(", %s",str);
  ShutDown();
  exit(0);
  return 1;
} /* ExitProc */

