#include "SDPdef.h"

sdpdat  *sdat;
clock_t *stim;
FILE    *fout;
double  *dsdpmaty0;


int main(int argc,char *argv[])
{
  int     i,n,beg, ierr,dConstraints;
  long int j;
  double  spar=0,spar2=0;
  sdpdat  sdt= {0};
  char    *cs,ss[40];
  clock_t tim[5]={0};


  PrintHeader();
  sdat=&sdt;
  stim= tim;
  
  beg=CheckArgs(argc,argv,"-f");
  if (beg) {
    cs=argv[beg];
    sprintf(sdt.ss,"%s",cs);
  }
  else {
    printf(" Please type the name of your data file: ");
    fflush(stdin);
    scanf("%s",sdt.ss);
  }

  fout=fopen(sdt.ss,"r");
  if (!fout)
    ExitProc(ReadFail,sdt.ss);
    
  fclose(fout);
  fout=NULL;

  beg=CheckArgs(argc,argv,"-s");
  if (beg) 
  {
    cs=argv[beg];
    sprintf(sdt.spc,"%s",cs);
  }

  SetParams(&sdt);  /* Set parameters */

  if (sdt.par.printit == TRUE){
    sprintf(ss,"%s.rec",sdt.ss);
    fout=fopen(ss,"w");
    if (!fout) ExitProc(WriteFail,ss);
    else PrintParams(&sdt);
  } else fout = NULL;



  /* Read data from files and user (sdpinput.c) */
  if (!DataIn(&sdt)){
    ShutDown(); 
    return FALSE;
  }

  /* Create Cholesky factor structures */
  dConstraints = FindDenseMatrix(&sdt);  
  sdt.smw= wAlloc(dConstraints,sdt.n);  
  j=0;
  for (i=0; i<sdt.m; i++){
    if (sdt.useSMW[i] > 0){
      sdt.smw->dind[j]=i;
      j++;
    }
  }
  sdt.smw->ndense = dConstraints;
  if (dConstraints > 0) sdt.par.usepotential = FALSE;
  CreateS(&sdt,&spar);    
  MchlSetup(&sdt);

  ierr = InitialPoint(&sdt);  /* Allocate memory and initialize it. */
  if (ierr){  
    ShutDown();   /* DeAllocate memory */
    SetTime(stim,ELAPSED);
    return FALSE;
  }

  n=sdt.n;
  spar2=(sdt.sf->unnz+n)*2.0/(n*n+n+1e-10)*100.0;
  SetTime(stim,DATAIN);
  PrintTitle(&sdt, spar,spar2);
  PrintIt(&sdt, 0 );

  DualSDP(&sdt);
  PrintEndSDP();
  SetTime(stim,DUALALG);
  if (sdt.par.save_y == TRUE)
    SaveSolution(sdt.pobj, sdt.y, sdt.m, sdt.youtput, sdt.par.minimize);


  if (sdt.par.findrank1sol>0 ) RankReduce(&sdt);  
  SetTime(stim, INTEG);


  ShutDown();   /* DeAllocate memory */
  SetTime(stim,ELAPSED);
  
  PrintEnd(stim);
  

  if (fout) fclose(fout);
  return TRUE;   
} /* main */


