#include "SDPdef.h"

static void setXYind(int     nnz,
                     double* y,
                     double* x,
                     int*    s)
{
  int i;
  
  for(i=0; i<nnz; ++i) {
    x[i]=y[s[i]];
    y[s[i]]=0.0;
  }
} /* setXYind */

static void setColi(chfac*  cl,
                    int     i,
                    double* ai)
{
  setXYind(cl->ujsze[i],ai,
           cl->uval+cl->uhead[i],
           cl->usub+cl->ujbeg[i]);
} /* setColi */

int NumChol(sdpdat* sdt,double* y,int mode)
{
  symat*     c;
  smatx*     a;
  chfac*     sf;
  spvec      *cj,*ai;
  double     rtmp,*row;
  int        h,i,j,k,n,m,nil,next,*iden,*jcur,*jfir,*jnex,*invp;
 
  h = -1;  /* Arbitrary */
  rtmp = 1.1; /* Arbitrary */
   
  n  =sdt->n;
  m  =sdt->m;
  k  =max(n,m);
  
  sdt->iw=iAlloc(3*k,NULL);
  sdt->rw=dAlloc(2*k,NULL);
  
  c  =sdt->cmat;
  a  =sdt->amats;
  sf =sdt->sf;
  row=sdt->rw;
  
  iden=sdt->useSMW;
  jcur=sdt->iw;
  jfir=jcur+n;
  jnex=jfir+n;
  invp=sf->invp;
  nil =n;
  
  for (i=0; i<n; i++)
    jfir[i]=nil;
    
  for (j=0; j<n; j++)
  {
    jcur[j]=0;
    cj=c->roff+j;
    if (cj->nn0>0)
    {
      i=cj->ja[0];
      jnex[j]=jfir[i];
      jfir[i]=j;
    }
    else
      jnex[j]=nil;
  }
  
  for (j=0; j<n; j++)
  {
    sf->diag[invp[j]]=c->diag[j];
    memset(row,0,n*sizeof(double));
    cj=c->roff+j;
    for (k=0; k<cj->nn0; k++)
      row[invp[cj->ja[k]]]=cj->an[k];
      
    for (i=jfir[j]; i!=nil; i=next)
    {
      next=jnex[i];
      cj=c->roff+i;
      row[invp[i]]=cj->an[jcur[i]];
      jcur[i]++;
         
      if (jcur[i]<cj->nn0)
      {
        k=cj->ja[jcur[i]];
        jnex[i]=jfir[k];
        jfir[k]=i;
      }
    } 
    for (i=0; i<m; i++)
    {
      if (iden[i])
        continue;
        
      ai=a->rows+i;
      for (k=0; k<ai->nn0; k++)
      {
        h=ai->ja[k];
        if (h==j)
        {
          rtmp=ai->an[k]*y[i];
          break;
        }
      }
      if (h==j)
      {
        for (k=0; k<ai->nn0; k++)
        {
          h=ai->ja[k];
          if (h!=j)
            row[invp[h]]-=rtmp*ai->an[k];
          else
            sf->diag[invp[j]]-=rtmp*ai->an[k];
        }
      }
    }
    setColi(sf,invp[j],row);
  }


	if (CfcOk!=ChlFact(sf,sdt->iw,sdt->rw,mode) ){ 
	/*    ExitProc(CholErr,NULL); */
		return FALSE;
	}
	else {    
	  return TRUE;
	}

} /* NumChol */
